// RTB's Pref Manager Sucks

function Bp()
{
	exec("./server.cs");
}

function BpStripCategory(%name)
{
	%strip = trim(getSubStr(strchr(%name, "-"), 1, 256));

	if(%strip $= "")
	{
		%strip = trim(getSubStr(strchr(%name, "|"), 1, 256));

		if(%strip $= "")
			return %name;
	}

	return %strip;
}

function BpGetGlobal(%name)
{
	if(strlen(%name) <= 0)
		return "";

	if(getSubStr(%name, 0, 1) $= "$")
		%name = getSubStr(%name, 1, 255);

	eval("%val = $" @ getSubStr(%name, 0, 1) @ "[\"" @ expandEscape(getSubStr(%name, 1, 255)) @ "\"];");

	return %val;
}

function BpSetGlobal(%name, %value)
{
	if(strlen(%name) <= 0)
		return "";

	if(getSubStr(%name, 0, 1) $= "$")
		%name = getSubStr(%name, 1, 255);

	eval("$" @ getSubStr(%name, 0, 1) @ "[\"" @ expandEscape(getSubStr(%name, 1, 255)) @ "\"] = \"" @ expandEscape(%value) @ "\";");
}

function serverCmdBpRequestPrefList(%cl, %force)
{
	if(!%cl.hasRTB || !%cl.isSuperAdmin)
		return;

	if(!%cl.hasPrefList)
		RTBSC_sendPrefList(%cl);

	if((!%cl.hasBpPrefList || %force))
	{
		%cts = $RTB::SServerControl::SP::Prefs;

		for(%i = 0; %i < %cts; %i++)
		{
			%data = $RTB::SServerControl::SP::Pref[%i];

			commandToClient(%cl, 'BpRegisterPref',
				getSubStr(%data, 0, 255),
				getSubStr(%data, 255, 255),
				getSubStr(%data, 255 * 2, 255),
				getSubStr(%data, 255 * 3, 255),
				getSubStr(%data, 255 * 4, 255),
				$RTB::SServerControl::SP::PrefDefault[%i],
				BpGetGlobal(getField(%data, 1)));
		}

		%cl.hasBpPrefList = true;
	}

	commandToClient(%cl, 'BpPrefsDone', %cl.getBLID() == getNumKeyID());
}

function serverCmdBpSetPrefValue(%cl, %pref, %val)
{
	if(!%cl.hasRTB || !%cl.isSuperAdmin || !%cl.hasPrefList || !%cl.hasBpPrefList)
		return;

	%data = $RTB::SServerControl::SP::Pref[%pref];
	%global = getField(%data, 1);

	%old = BpGetGlobal(%global);

	if(%old $= %val)
		return;

	BpSetGlobal(%global, %val);

	if(getField(%data, 7) !$= "")
		call(getField(%data, 7), %old, %val);

	for(%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%cc = ClientGroup.getObject(%i);
		if(%cc.isSuperAdmin && %cc.hasRTB && %cc.hasPrefList)
			RTBSC_SendPrefValues(%cc);
	}

	RTBSC_savePrefValues();

	%tag = '';

	if(getSimTime() - $LastBpUpdate > 100)
		%tag = 'MsgAdminForce';

	%type = getField(%data, 3);
	%typeFW = firstWord(%type);
	if(%typeFW $= "list")
	{
		%valN = getWord(%type, 1 + %val * 2);
		%oldN = getWord(%type, 1 + %old * 2);
	}
	else if(%typeFW $= "datablock")
	{
		%valN = %val.uiName;
		%oldN = %old.uiName;
	}
	else if(%typeFW $= "bool")
	{
		%valN = %val ? "true" : "false";
		%oldN = %old ? "true" : "false";
	}
	else
	{
		%valN = %val;
		%oldN = %old;
	}

	messageAll(%tag, '\c3%1\c5 changed \c2%2\c5: \c2%3\c5 - \c2%4\c5 to \c3%5\c5 (was \c3%6\c5)', %cl.name, getField(%data, 4), BpStripCategory(getField(%data, 2)), getField(%data, 0), %valN, %oldN);

	$LastBpUpdate = getSimTime();
}